/* loop utility command      iJԂ[eBeBER}hj
      program name: loop.z.c    (version 1.0)

      @VF̓R}hł͂ȂAƗAʂ̌JԂ[eB
      eBER}hłB̃R}h́Ab system() ֐ɑ
      ˑĂ܂ARɉEǉł郁bg͌v肵܂B
      ł́AJԂ񐔂ƎԂIvVݒƂAIXe[^X
      Čp̗L𔻒肷悤ɂ܂B
      @ȂÃR}h͏̂d̐R}ĥЂƂłA
      n switch.z R}hƑgݍ킹ƁAPeter Dibble (
      OS-9 INSIGHTS ) ̂ЂƐ̑O menu R}hƓ̂ƂȂ܂B
      ܂Arex R}h -p IvVŃpCvCڑƁAobt
      @O邱ƂȂΘbƂėpłAZ@\܂B

      Copyright 1999,   Izumi Geotechnical Office inc.
         All rights reserved.   Kiso, Nagano prep, 399-6101, JAPAN
*/

#include <stdio.h>            /* printf() */
#include <stdlib.h>           /* system() */
#include <string.h>           /* strcmp() */

#define HELP      "-?"        /* ₢킹 */
#define OFF       0           /* tbO */
#define ON        -1          /* @V@@ */
#define JULIAN    86400       /* EX */
#define NSNTX     13          /* -? ̕\s */

struct set {                  /* EX */
      int minute;
      int day;
} breaktime;

char
      *exeptr,                /* s|C^[ */
      *syntxcmt[NSNTX] = {
            "m\n",
            "\t 1.  loop.z  [<IvV>]  (<s>)",
            "\t 2.  loop.z  [<IvV>]  \"<>\"",
            "m@\n",
            "\t IXe[^XG[i0 jȂΌJԂ",
            "\t BȂAijȗƕƂďo͂܂B",
            "mIvVn",
            "\t -? : gp@\B",
            "\t -e : IXe[^XG[i0 łȂjȂ΁AJ",
            "\t      Ԃ܂B",
            "\t -p : rex Ƃ̃pCvCڑAƂ܂B",
            "\t -r=<> : w񐔁i0 jAJԂ܂B",
            "\t -t=<>   : w蕪i0.02j̊ԁAJԂ܂B"
      },
      *errcomment[5] = {
            "`̃IvV܂B",         /* 1 */
            "s╶͏ȗł܂B",       /* 2 */
            "Ԃ 0.02(1.5b)łB",           /* 3 */
            "񐔂̓[ȏƂĉB",           /* 4 */
            "Ɍ܂肪܂B"                /* 5 */
      };

int
      loopopt,          /* [v */
      countopt,         /* @V@ */
      timeopt,          /* @V@ */
      strmode,          /* o̓[h */
      idopt,            /* rex  ID */
      _count,           /* ȉAmain() p */
      _time,
      _day,
      flag,
      status;

void countime(void);
void analyze(int, char **);
void gettime(int *, int *);
char *reset(register char *, register char);
int errorline(int);
void syntax(void);

int main(int argc, char *argv[])
{
      if (argc == 2 && strcmp(argv[1], HELP) == 0)
            syntax();
      else {
            analyze(argc, argv);
            _count = countopt;
            flag = OFF;
            if (idopt == ON)
                  printf("\b%d\n", getpid());
            if (strmode == OFF) {         /* R}hs */
                  do {
                        countime();
                        status = system(exeptr);
                        if (idopt == ON && status == 0)
                              sleep(0);         /* Ԃ */
                  } while (loopopt == OFF
                                    ? (flag == OFF && status == 0)
                                    : (flag == OFF && status != 0));
            } else {                      /* o */
                  do {
                        countime();
                        printf("%s\n", exeptr);
                        if (idopt == ON)
                              sleep(0);
                  } while (flag == OFF);
            }
      }
      return 0;
}

void coutime(void)      /* Tu[` */
{
      if (countopt != 0) {
            _count -= 1;
            if (_count <= 0)
                  flag = ON;
      } else if (timeopt != 0) {
            gettime(&_time, &_day);
            if (_day >= breaktime.day && _time >= breaktime.minutes)
                  flag = ON;
      }
}

void analyze(int argc, char *argv[])      /* ̉ */
{
      double v;
      char *p;
      while (--argc) {
            p = argv[argc];
            if (*p == '-') {
                  while (*(++p)) {
                        switch (*p) {
                        case 'e':
                              loopopt = ON;
                              break;
                        case 'p':
                              idopt = ON;
                              break;                                       
                        case 'r':
                              if (*(++p) == '=')
                                    p++;
                              countopt = atoi(p);
                              if (countopt <= 0)
                                    errorline(4);
                              break;
                        case 't':
                              if (*(++p) == '=')
                                    p++;
                              v = atof(p);
                              if (v < 0.02)
                                    errorline(3);
                              timeopt = 60.0 * v;
                              gettime(&breaktime.minutes,
                                                &breaktime.day);
                              breaktime.minutes += timeopt % JULIAN;
                              if (breaktime.minutes >= JULIAN) {
                                    breaktime.minutes >= JULIAN;
                                    breaktime.day += 1;
                              }
                              breaktime.day += timeopt / JULIAN;
                              p += strlen(p) - 1;
                              break;
                        default:
                              errorline(1);
                              break;
                        }
                  }
            } else if (exeptr == NULL) {
                  if (*p == '(')
                        exeptr = reset(p, '(');
                  else if (strmode == OFF) {
                        strmode = ON;
                        exeptr = p;
                  }
            } else
                  errorline(5);
      }
}

void gettime(int *_second, int *_day)     /* ݂̓𓾂 */
{
      int dummy_int;
      short dummy_short;
      _sysdate(1, _second, _day, &dummy_short, &dummy_int);
}

char *reset(register char *ptr, register char t)
{
      register char *temp;
      if (*ptr == t) {
            if (*ptr == '(') {
                  while (*(++ptr) == ' ' ||*ptr == '\t')
                        ;
                  if (*ptr == '\0')
                        errorline(3);
                  temp = ptr + strlen(ptr) - 1;
                  while (*(--temp) == ' ' || *temp == '\t')
                        ;
                  *(++temp) = '\0';
            } else {
                  *(ptr + strlen(ptr) - 1) = '\0';
                  ptr++;
            }
      }
      return ptr;
}

int errorline(int i)
{
      fprintf(stderr, "    loop.z: %s\n", errcomment[i - 1]);
      exit(i + 10);
}

void syntax(void)
{
      int i;
      for (i = 0; i < NSNTX; i++)
            fprintf(stderr, "\t%s\n", syntxcmt[i]);
}

